<?php

namespace App\Http\Controllers\V1;

use App\Events\CardCertifiedEvent;
use App\Events\ExampleEvent;
use App\Handlers\BikeControl;
use App\Jobs\SendSMSBikeTemporaryWaitOverThirtyJob;
use App\Maps\CacheMap;
use App\Models\Bike;
use App\Models\InviteNewUser;
use App\Models\User;
use App\Repositories\AreaRepository;
use App\Repositories\BikeRepository;
use App\Repositories\LocationLogRepository;
use App\Repositories\RefundLogRepository;
use App\Repositories\UserRepository;
use App\Transformers\UserTransformer;
use Carbon\Carbon;
use Dingo\Api\Http\Request;
use GatewayClient\Gateway;
use Illuminate\Support\Facades\Event;
use Illuminate\Support\Facades\Log;
use Tymon\JWTAuth\Facades\JWTAuth;
use Illuminate\Support\Facades\Redis;
use Illuminate\Support\Facades\Cache;

/**
 * 测试模块
 * Class ExampleController
 * @package App\Http\Controllers\V1
 */
class ExampleController extends BaseController
{
    protected $userRepository;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct(UserRepository $userRepository)
    {
        $this->userRepository = $userRepository;
    }

    /**
     * @param Request $request
     * @return \Dingo\Api\Http\Response|string
     * User: Mead
     */
    public function index(Request $request)
    {
        $user = $this->userRepository->byIdGetModel(1);
        if (is_null($user)) {
            $this->response->errorNotFound('no data');
            return '';
        }
        return $this->response->item($user, UserTransformer::class);
    }

    public function orderRefund()
    {
//        $orders = Order::where('pay_status', Order::PAY_STATUS_OK)->whereDate('pay_time', Carbon::parse('-1 day')->toDateString())->get();
//        $payment = app('wechat.payment'); // 微信支付
//        foreach ($orders as $order) {
//            $result = $payment->refund->byOutTradeNumber($order->no, $order->no, wechat_fee($order->pay_money), wechat_fee($order->pay_money), [
//                // 可在此处传入其他参数，详细参数见微信支付文档
//                'refund_desc' => '退支付金额'
//            ]);
//        }
//        echo 'ok';
    }

    public function batterOpen(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::openBatteryLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function batterClose(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::closeBatteryLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function bikeClose(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::closeLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function bikeOpen(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::openLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function bikeBell(Request $request, BikeRepository $bikeRepository)
    {
        $bike_no = $request->get('bike_no');
        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
        BikeControl::bellBike($box_no);
        return [
            'status' => true
        ];
    }

    public function bikeInfo(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $info = $bikeRepository->byBikeNo($bike_no);
//        Gateway::$registerAddress = '127.0.0.1:1238';
//        return [
//            'battery_power' => $info->battery_power,
//            'is_online' => Gateway::isUidOnline($info->box_no),
//            'lists' => Gateway::getAllUidList(),
//            'count' => Gateway::getAllClientCount(),
//            'bike_no' => $info->bike_no,
//            'box_no' => $info->box_no,
//        ];
    }

    public function test(Request $request, BikeRepository $bikeRepository, LocationLogRepository $locationLogRepository, AreaRepository $areaRepository, RefundLogRepository $refundLogRepository)
    {

        Gateway::$registerAddress = 'node1:2238';
        $list = Gateway::getAllUidList();
        var_dump($list);

        $is_ok = \App\Handlers\Weikemu\BikeControl::playVoice('868626040174578', '01');
        $is_ok = \App\Handlers\Weikemu\BikeControl::realLocation('868626040174578', '01');
        dd($is_ok);
//        abort(423, 'mead error');
//        Cache::flush();
//        $user = User::find(3);
//        Log::info($user);
//        event(new CardCertifiedEvent($user));
//        // Event::dispatch(new ExampleEvent);
//
//        dd(111);
////        $res = InviteNewUser::query()
////            ->where('invite_id', 2)
////            ->where('status', InviteNewUser::STATUS_OK)
////            ->where('is_card_certified', InviteNewUser::CARD_CERTIFIED_OK)
////            ->limit(1)
////            ->pluck('register_id')
////            ->toArray();
////
////        dd(count($res));
//        Gateway::$registerAddress = 'node1:1238';
//        BikeControl::playVideo('003472969', BikeControl::VIDEO_OUT_AREA_CLOSE_ELECTRIC);
//
////        Cache::flush();
//        for ($i = 0; $i < 30; $i++) {
//            sleep(1);
//        }
//        return $this->success();
        dda('ok');
    }

    public function check()
    {
        return $this->success();
    }

    public function token()
    {
        $user = $this->userRepository->byIdGetModel(3);
        $token = JWTAuth::fromUser($user);
        return $this->response->array([
            'token' => 'Bearer ' . $token,
            'ttl' => Carbon::now()->addMinute(JWTAuth::factory()->getTTL())->getTimestamp()
        ]);
    }
}
