<?php
/**
 * Created by PhpStorm.
 * User: Mead
 * Date: 2019/8/19
 * Time: 2:11 PM
 */

namespace App\Http\Controllers\V1;

use App\Http\Requests\UpTroubleRequest;
use App\Models\Trouble;
use App\Models\Upload;

/**
 * 故障报修模块
 * Class TroubleController
 * @package App\Http\Controllers\V1
 */
class TroubleController extends BaseController
{
    /**
     * 故障报修
     * @param UpTroubleRequest $request
     * User: Mead
     */
    public function store(UpTroubleRequest $request)
    {
        try {
            $re = Trouble::create([
                'user_id' => $this->user->id,
                'bike_no' => $request->get('bike_no'),
                'area_id' => $request->get('area_id'),
                'trouble_part' => $request->get('trouble_part'),
                'trouble_description' => $request->get('trouble_description'),
                'trouble_imgs' => str2arr($request->get('trouble_imgs')),
                'up_trouble_type' => Trouble::UP_TYPE_COMMON
            ]);

            if (count($re->trouble_imgs)) {
                Upload::whereIn('id', $re->trouble_imgs)->update(['is_use' => Upload::USE_OK]);
            }

            return $this->response->array([
                'is_up_trouble' => !!$re
            ]);
        } catch (\Exception $exception) {
            return $this->errorNoValidation($exception->getMessage());
        }
    }
}