<?php

namespace App\Http\Middleware;

use App\Maps\CacheMap;
use Closure;
use Illuminate\Contracts\Auth\Factory as Auth;
use Illuminate\Support\Facades\Log;
use Tymon\JWTAuth\Facades\JWTAuth;

class SingleLoginLimit
{

    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        $user_id = JWTAuth::parseToken()->authenticate()->id;
        $token = JWTAuth::getToken();
//        return $next($request);
        $redisToken = app()->redis->hget(CacheMap::SINGLE_LOGIN_API,$user_id);
        if($token != $redisToken){
            JWTAuth::parseToken()->invalidate();
        }
        return $next($request);
    }
}
