<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Coupon extends Model
{
    //
    protected $table = 'coupons';
    protected $guarded = [];

    const TYPE_MAN_JIAN = 1;
    const TYPE_WU_MEN_KAN = 2;
    const TYPE_ZHE_KOU = 3;
    public static $typeMaps = [
        self::TYPE_MAN_JIAN => '满减优惠',
        self::TYPE_WU_MEN_KAN => '无门槛优惠',
        self::TYPE_ZHE_KOU => '折扣优惠'
    ];

    const QUOTA_OK = 1;
    const QUOTA_NO = 0;
    public static $quotaMaps = [
      self::QUOTA_NO => '不限发放数量',
      self::QUOTA_OK => '限制发放数量',
    ];

    const VALID_TYPE_ABSOLUTELY = 1;
    const VALID_TYPE_RELATIVE = 2;
    public static $validTypeMaps = [
      self::VALID_TYPE_ABSOLUTELY => '绝对时效',
      self::VALID_TYPE_RELATIVE => '相对时效',
    ];

    const STATUS_OK = 1;
    const STATUS_NO = 0;
    const STATUS_USED = 2;
    public static $statusMaps = [
        self::STATUS_OK=>'启用',
        self::STATUS_NO=>'停用',
        self::STATUS_USED=>'已使用',
    ];

    const ORDER_TYPE_NORMAL = 1;
    const ORDER_TYPE_RENT = 2;
    const ORDER_TYPE_ALL = 3;
    public static $orderTypeMaps = [
        self::ORDER_TYPE_NORMAL => '仅普通订单可用',
        self::ORDER_TYPE_RENT => '仅日租订单可用',
        self::ORDER_TYPE_ALL => '所有订单可用',
    ];

    public function areas(){
        return $this->belongsTo(Area::class,'area_id','id');
    }

    // 优惠券被使用  更新优惠券信息
    public static function couponUsed($id){
        self::query()->where('id',$id)->increment('used_count');
    }
}
