<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class RentOrderBikeOperate extends Model
{
    protected $guarded = [];


    const STATUS_OK = 1;
    const STATUS_PAUSE = 0;
    public static $statusMaps = [
        self::STATUS_OK => '正常',
        self::STATUS_PAUSE => '暂停'
    ];

    const TYPE_NULL = 0;
    const TYPE_BILL_BIKE = 1;
    const TYPE_OPEN_BIKE = 2;
    const TYPE_CLONE_BIKE = 3;
    const TYPE_PAUSE_OPEN_BIKE = 4;
    const TYPE_PAUSE_CLONE_BIKE = 5;

    public static $typeMaps = [
        self::TYPE_NULL => '未知',
        self::TYPE_BILL_BIKE => '寻车',
        self::TYPE_OPEN_BIKE => '开锁',
        self::TYPE_CLONE_BIKE => '关锁',
        self::TYPE_PAUSE_OPEN_BIKE => '开锁（重试开车）',
        self::TYPE_PAUSE_CLONE_BIKE => '关锁（重试关车）'

    ];


    const IS_ADMIN_NO = 'F';
    const IS_ADMIN_YES = 'T';
    const IS_ADMIN_SYSTEM = 'S';
    public static $isAdminMaps = [
        self::IS_ADMIN_NO => '用户操作',
        self::IS_ADMIN_YES => '管理员操作',
        self::IS_ADMIN_SYSTEM => '系统操作'
    ];


    public static function log($order_id, $type, $bike_id, $user_id, $lat, $lng, $is_admin = self::IS_ADMIN_NO)
    {
        $data = [
            'order_id' => $order_id,
            'name' => self::$typeMaps[$type],
            'type' => $type,
            'bike_id' => $bike_id,
            'user_id' => $user_id,
            'latitude' => $lat,
            'longitude' => $lng,
            'is_admin' => $is_admin
        ];
        self::create($data);
    }

}
