<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class WarningLog extends Model
{
    protected $guarded = [];

    //备用
    const TYPE_DEFAULT = 0;

    // 电池电量低
    const TYPE_BATTERY_LOW = 11;
    //异常订单
    const TYPE_ABNORMAL_ORDER = 12;
    // 电车骑出骑行区域
    const TYPE_BIKE_OUT_AREA = 21;
    // 电车骑出骑行区域的辐射范围
    const TYPE_BIKE_OUT_AREA_ = 22;

    //备用电池低电告警
    const TYPE_WARNING_BATTERY_LOW = 31;
    //震动报警
    const TYPE_WARNING_BIKE_SHOCK = 32;
    //非法打开电门报警
    const TYPE_WARNING_BIKE_OPEN = 33;
    //电子围栏报警
    const TYPE_WARNING_FENCE = 34;
//    BMS异常报警
    const TYPE_WARNING_BMS = 35;
//    断电报警、GPS自检测
    const TYPE_WARNING_CLOSE_ELECTRIC = 36;
//    超速告警
    const TYPE_WARNING_OVER_SPEED = 37;
    //轮动告警
    const TYPE_WARNING_WHEEL_MOVE = 38;
    //车辆故障
    const TYPE_WARNING_BIKE_TROUBLE = 39;


    /**
     * 错误等级
     */
    //    默认
    const ERROR_GRADE_DEFAULT = 0;
//    次要
    const ERROR_GRADE_MINOR = 1;
//    一般
    const ERROR_GRADE_MAJOR = 2;
//    重要
    const ERROR_GRADE_CRITICAL = 3;
    //立马解决/**/
    const ERROR_GRADE_NOW = 4;

    public function getBodyAttribute($v)
    {
        return unserialize($v);
    }

}
