<?php


namespace App\Transformers;


use App\Models\CardRiding;
use League\Fractal\TransformerAbstract;

class CardRidingsTransformer extends TransformerAbstract
{
    public function transform(CardRiding $model)
    {
        $now_price = $model->price;
        if($model->is_discount == CardRiding::DISCOUNT_YES){
            $now_price = bcmul($now_price,$model->discount,2);
        }
        return [
            'id' => $model->id,
            'is_limit_times' => $model->is_limit_times,
            'effective_days' => $model->effective_days,
            'deduction_money' => $model->deduction_money,
            'times' => $model->times,
            'price' => $model->price,
            'now_price' => $now_price,
            'is_discount' => $model->is_discount,
            'discount' => bcmul($model->discount,10),
        ];
    }
}
