<?php

return [

    /*
    |--------------------------------------------------------------------------
    | HTTP 请求的超时时间
    |--------------------------------------------------------------------------
    |
    | 设置 HTTP 请求超时时间，单位为「秒」。可以为 int 或者 float。
    |
    */

    'timeout' => 5.0,

    /*
    |--------------------------------------------------------------------------
    | 默认发送配置
    |--------------------------------------------------------------------------
    |
    | strategy 为策略器，默认使用「顺序策略器」，可选值有：
    |       - \Overtrue\EasySms\Strategies\OrderStrategy::class  顺序策略器
    |       - \Overtrue\EasySms\Strategies\RandomStrategy::class 随机策略器
    |
    | gateways 设置可用的发送网关，可用网关：
    |       - alidayu 阿里云信
    |       - alidayu 阿里大于
    |       - yunpian 云片
    |       - submail Submail
    |       - luosimao 螺丝帽
    |       - yuntongxun 容联云通讯
    |       - huyi 互亿无线
    |       - juhe 聚合数据
    |       - sendcloud SendCloud
    |       - baidu 百度云
    |
    */

    'default' => [
        'strategy' => \Overtrue\EasySms\Strategies\OrderStrategy::class,
        'gateways' => ['qcloud'],
    ],

    /*
    |--------------------------------------------------------------------------
    | 发送网关配置
    |--------------------------------------------------------------------------
    |
    | 可用的发送网关，基于网关列表，这里配置可用的发送网关必要的数据信息。
    |
    */

    'gateways' => [
        'qcloud' => [
            'sdk_app_id' => '1400267476', // SDK APP ID
            'app_key' => '9cd728b5df33a104960d2bf027637ddb', // APP KEY
            'sign_name' => '未来bike', // 短信签名，如果使用默认签名，该字段可缺省（对应官方文档中的sign）
        ],
        'aliyun' => [
            'access_key_id' => 'LTAI6U9cR490rxUu',
            'access_key_secret' => 'nb9j2uQlwnoGg3wRZrcTwBs4m83A1l',
            'sign_name' => '阿里云短信测试专用',
        ]
    ],

    /*
    |--------------------------------------------------------------------------
    | 消息支持频道
    |--------------------------------------------------------------------------
    |
    | 发送消息可用根据不同频道配置注入不同频道配置数据。
    |
    */

    'channels' => [

        // 验证码频道
        'code' => [
            'alidayu' => [
                'template' => null,
            ],
        ],
    ],
];