<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateBikesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('bikes', function (Blueprint $table) {
            $table->bigIncrements('id');

            $table->string('bike_no', 30)->comment('车辆编号');
            $table->string('box_no', 30)->nullable()->comment('控制设备编号');
            $table->string('blu_key', 32)->nullable()->comment('蓝牙key');
            $table->tinyInteger('battery_power')->default(0)->comment('电量');
            $table->tinyInteger('is_link')->default(0)->comment('是否在线');
            $table->tinyInteger('is_lock')->default(0)->comment('是否锁车');
            $table->tinyInteger('is_low_battery_power')->default(0)->comment('是否电量低');
            $table->tinyInteger('is_riding')->default(0)->comment('是否骑行');
            $table->tinyInteger('is_trouble')->default(0)->comment('是否故障');
            $table->timestamp('last_use_bike_end_time')->nullable()->comment('最后骑行时间');

            $table->string('last_location')->nullable()->comment('最后位置信息');
            $table->timestamp('last_location_time')->nullable()->comment('最后定位时间');

            $table->bigInteger('put_area_id')->default(0)->comment('投放区域id');
            $table->tinyInteger('put_status')->default(0)->comment('投放状态');
            $table->timestamp('put_time')->nullable()->comment('投放时间');
            $table->string('blu_ase_key', 100)->nullable()->comment('蓝牙key+box_no = 秘钥');

            $table->tinyInteger('status')->default(1);

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('bikes');
    }
}
